import 'package:vaycore/dartin.dart';

///
/// @author vay
/// @email hxhvay@126.com
/// @date 2020-05-09
///

class VayCoreOptions {
  /// 调式模式
  bool isDebug;

  /// 屏幕适配对应的屏幕宽度（UI设计图的宽度）
  final double adapterWidth;

  /// 网络日志打印配置
  HttpLogOptions logOptions;

  /// 需要支持依赖注入的模块
  List<Module> modules;

  VayCoreOptions(
      {this.isDebug = false,
      this.adapterWidth = 375,
      this.logOptions,
      this.modules}) {
    this.logOptions = this.logOptions ?? HttpLogOptions();
  }
}

class HttpLogOptions {
  final bool request;
  final bool requestHeader;
  final bool requestBody;
  final bool responseHeader;
  final bool responseBody;
  final bool error;
  void Function(Object object) logPrint;

  HttpLogOptions({
    this.request = false,
    this.requestHeader = true,
    this.requestBody = true,
    this.responseHeader = false,
    this.responseBody = true,
    this.error = true,
    this.logPrint = print,
  });
}
