import 'package:vaycore/http.dart';

///
/// @author vay
/// @email hxhvay@126.com
/// @date 2020-05-09
///

class RequestParams {
  String _url;
  HttpMethod _method;
  int _timeout;
  String _contentType;
  dynamic _responseType;
  Map<String, dynamic> _data;
  Map<String, dynamic> _header;
  int _retryCount;
  dynamic _transformer;
  List<dynamic> _interceptors;
  Parser _parser;

  RequestParams(RequestParamsBuilder builder) {
    assert(builder != null);
    this._url = builder._url;
    this._method = builder._method;
    this._timeout = builder._timeout;
    this._contentType = builder._contentType;
    this._responseType = builder._responseType;
    this._data = builder._data;
    this._header = builder._header;
    this._retryCount = builder._retryCount;
    this._transformer = builder._transformer;
    this._interceptors = builder._interceptors;
    this._parser = builder._parser;
  }

  static RequestParamsBuilder builder() {
    return RequestParamsBuilder();
  }

  Parser get parser => _parser;

  List<dynamic> get interceptors => _interceptors;

  dynamic get transformer => _transformer;

  int get retryCount => _retryCount;

  Map<String, dynamic> get header => _header;

  Map<String, dynamic> get data => _data;

  dynamic get responseType => _responseType;

  String get contentType => _contentType;

  int get timeout => _timeout;

  HttpMethod get method => _method;

  String get url => _url;
}

class RequestParamsBuilder {
  String _url;
  HttpMethod _method;
  int _timeout;
  String _contentType;
  dynamic _responseType;
  Map<String, dynamic> _data;
  Map<String, dynamic> _header;
  int _retryCount;
  List<dynamic> _interceptors;
  dynamic _transformer;

  Parser _parser;

  RequestParamsBuilder setUrl(String value) {
    _url = value;
    return this;
  }

  RequestParamsBuilder setMethod(HttpMethod value) {
    _method = value;
    return this;
  }

  RequestParamsBuilder setTimeout(int value) {
    _timeout = value;
    return this;
  }

  RequestParamsBuilder setContentType(String value) {
    _contentType = value;
    return this;
  }

  RequestParamsBuilder setResponseType(dynamic value) {
    _responseType = value;
    return this;
  }

  RequestParamsBuilder setData(Map<String, dynamic> value) {
    _data = value;
    return this;
  }

  RequestParamsBuilder setHeader(Map<String, dynamic> value) {
    _header = value;
    return this;
  }

  RequestParamsBuilder setRetryCount(int value) {
    _retryCount = value;
    return this;
  }

  RequestParamsBuilder setTransformer(dynamic value) {
    _transformer = value;
    return this;
  }

  RequestParamsBuilder setInterceptors(List<dynamic> interceptors) {
    _interceptors = interceptors;
    return this;
  }

  RequestParamsBuilder setParser(Parser value) {
    _parser = value;
    return this;
  }

  RequestParams build() {
    return RequestParams(this);
  }
}
